// Generated by CoffeeScript 2.3.1
(function() {
  var GET, Reference, SET, Solid, reference_id;

  Solid = require('solid-gun');

  reference_id = function() {
    return Solid.time() + Solid.uniqueness();
  };

  // Just like RedisClient, this needs a `redis` value, which should be an instance of RedisInterface (`normal-key/interface`).
  SET = function(name) {
    return function(value) {
      return this.set(name, value);
    };
  };

  GET = function(name) {
    return function() {
      return this.get(name);
    };
  };

  Reference = (function() {
    class Reference {
      constructor(id) {
        if (id == null) {
          id = reference_id();
        }
        this.id = id;
      }

      _key(name) {
        return `xref-${this.id}.${name}`;
      }

      set(name, value) {
        var key;
        key = this._key(name);
        this.interface.setup_text(key, this.timeout);
        this.interface.update_text(key, value);
      }

      get(name) {
        var coherent, key, value;
        key = this._key(name);
        [coherent, value] = this.interface.get_text(key);
        return value;
      }

      add_tag(tag) {
        var key;
        key = this._key('tags');
        this.interface.setup_set(key, this.timeout);
        return this.interface.add(key, tag);
      }

      del_tag(tag) {
        var key;
        key = this._key('tags');
        this.interface.setup_set(key, this.timeout);
        return this.interface.remove(key, tag);
      }

      has_tag(tag) {
        var coherent, key, value;
        key = this._key('tags');
        [coherent, value] = this.interface.has(key, tag);
        return value;
      }

      tags() {
        var coherent, key, value;
        key = this._key('tags');
        [coherent, value] = this.interface.value(key);
        return value != null ? value : [];
      }

    };

    Reference.prototype.set_endpoint = SET('endpoint');

    Reference.prototype.set_destination = SET('destination');

    Reference.prototype.set_source = SET('source');

    Reference.prototype.set_domain = SET('domain');

    Reference.prototype.set_dev_logger = SET('dev_logger');

    Reference.prototype.set_account = SET('account');

    Reference.prototype.set_call_options = SET('call_options');

    Reference.prototype.set_block_dtmf = SET('block_dtmf');

    Reference.prototype.set_number = SET('number');

    Reference.prototype.set_number_domain = SET('number_domain');

    Reference.prototype.get_endpoint = GET('endpoint');

    Reference.prototype.get_destination = GET('destination');

    Reference.prototype.get_source = GET('source');

    Reference.prototype.get_domain = GET('domain');

    Reference.prototype.get_dev_logger = GET('dev_logger');

    Reference.prototype.get_account = GET('account');

    Reference.prototype.get_call_options = GET('call_options');

    Reference.prototype.get_block_dtmf = GET('block_dtmf');

    Reference.prototype.get_number = GET('number');

    Reference.prototype.get_number_domain = GET('number_domain');

    return Reference;

  }).call(this);

  module.exports = Reference;

}).call(this);
